from chatterbot import ChatBot 
import logging
from random import choice
import sys, os, random


# Uncomment the following line to enable verbose logging
# logging.basicConfig(level=logging.INFO)

from chatterbot.adapters.output import OutputAdapter
from chatterbot.utils.read_input import input_function


class MyAdapter(OutputAdapter):
    """
    A simple adapter that allows ChatterBot to
    communicate through the terminal.
    """

    def process_input(self, *args, **kwargs):
        """
        Read the user's input from the terminal.
        """
        user_input = input_function()
        return user_input

    def process_response(self, statement):
        """
        Print the response to the user's input.
        """
        cows = [
            'beavis.zen','bong','bud-frogs','bunny','cheese','cower','daemon','default','dragon',
            'dragon-and-cow','elephant','elephant-in-snake','eyes','flaming-sheep','ghostbusters',
            'head-in','hellokitty','kiss','kitty','koala','kosh','luke-koala','meow','milk','moofasa','moose',
            'mutilated','ren','satanic','sheep','skeleton','small','sodomized','stegosaurus','stimpy',
            'supermilker','surgery','telebears','three-eyes','turkey','turtle','tux','udder','vader',
            'vader-koala','www'
        ]

        args = [
            'b','d','g','p','s','t','w','y'
        ]
        
        i = statement.text 
        i = i.rstrip()

        if len(i) == 0:
            return i

        diff = random.randint(0, 9)
        if 0 ==diff:
            cow = cows[random.randint(0,len(cows) -1)]
            if ": " in i:
                (time, nick, msg) = i.split(" ", 2)
                if nick != 'hovelbot':
                    os.system('cowsay -f {0} "{1}"'.format(cow, msg))
            else:
                os.system('cowsay -f {0} "{1}"'.format(cow, i))
        elif 1 == diff:
            arg = args[random.randint(0,len(args) -1)]
            if ": " in i:
                (time, nick, msg) = i.split(" ", 2)
                if nick != 'hovelbot':
                    os.system('cowsay -{0} "{1}"'.format(arg, msg))
            else:
                os.system('cowsay -{0} "{1}"'.format(arg, i))
        else:
            if ": " in i:
                (time, nick, msg) = i.split(" ", 2)
                if nick != 'hovelbot':
                    os.system('cowsay "{0}"'.format(msg))
            else:
                os.system('cowsay "{0}"'.format(i))
        return i

# Create a new instance of a ChatBot
bot = ChatBot("Terminal",
    storage_adapter="chatterbot.adapters.storage.JsonFileStorageAdapter",
    logic_adapters=[
        "chatterbot.adapters.logic.MathematicalEvaluation",
        "chatterbot.adapters.logic.TimeLogicAdapter",
        "chatterbot.adapters.logic.ClosestMatchAdapter"
    ],
    input_adapter="chatterbot.adapters.input.TerminalAdapter",
    output_adapter="termbot.MyAdapter",
    database="database.db"
)

# The following loop will execute each time the user enters input
while True:
    try:
        # We pass None to this method because the parameter
        # is not used by the TerminalAdapter
        bot_input = bot.get_response(None)

    # Press ctrl-c or ctrl-d on the keyboard to exit
    except (KeyboardInterrupt, EOFError, SystemExit):
        break
