#!/bin/bash

th train.lua \
  -input_h5 data/frankenstein_for_machines.h5 \
  -input_json data/frankenstein_for_machines.json \
  -gpu -1 &

inotifywait -m cv -e create -e moved_to |
    while read path action file; do
        echo "The file '$file' appeared in directory '$path' via '$action'"
        # do something with the file
        if [ ${file: -3} == ".t7" ]
        then
           th sample.lua -checkpoint cv/$file -length 2000 -gpu -1 | python -u ircpipebot.py --server 10.1.1.1 --channel '#algolit' --nickname nnbot
        fi
    done
