// random int function
function randint(min,max)
{
    return Math.floor(Math.random()*(max-min+1)+min);
}

//lookup char to know if its a zalgo char or not
function is_zalgo_char(c)
{
				var i;
				for(i=0; i<zalgo_up.length; i++)
					if(c == zalgo_up[i])
						return true;
				for(i=0; i<zalgo_down.length; i++)
					if(c == zalgo_down[i])
						return true;
				for(i=0; i<zalgo_mid.length; i++)
					if(c == zalgo_mid[i])
						return true;
				return false;
			}


// Create the bot/client configuration
var irc = require('irc'); // find the library here: https://github.com/martynsmith/node-irc
var client = new irc.Client('chat.freenode.net', 'ZalgoBot', { //server name + nickname of the bot
    channels: ['#zallllgo'], //channel to join
});

//zalgo chars
var zalgo_up = [
				'\u030d', /*     ̍     */		'\u030e', /*     ̎     */		'\u0304', /*     ̄     */		'\u0305', /*     ̅     */
				'\u033f', /*     ̿     */		'\u0311', /*     ̑     */		'\u0306', /*     ̆     */		'\u0310', /*     ̐     */
				'\u0352', /*     ͒     */		'\u0357', /*     ͗     */		'\u0351', /*     ͑     */		'\u0307', /*     ̇     */
				'\u0308', /*     ̈     */		'\u030a', /*     ̊     */		'\u0342', /*     ͂     */		'\u0343', /*     ̓     */
				'\u0344', /*     ̈́     */		'\u034a', /*     ͊     */		'\u034b', /*     ͋     */		'\u034c', /*     ͌     */
				'\u0303', /*     ̃     */		'\u0302', /*     ̂     */		'\u030c', /*     ̌     */		'\u0350', /*     ͐     */
				'\u0300', /*     ̀     */		'\u0301', /*     ́     */		'\u030b', /*     ̋     */		'\u030f', /*     ̏     */
				'\u0312', /*     ̒     */		'\u0313', /*     ̓     */		'\u0314', /*     ̔     */		'\u033d', /*     ̽     */
				'\u0309', /*     ̉     */		'\u0363', /*     ͣ     */		'\u0364', /*     ͤ     */		'\u0365', /*     ͥ     */
				'\u0366', /*     ͦ     */		'\u0367', /*     ͧ     */		'\u0368', /*     ͨ     */		'\u0369', /*     ͩ     */
				'\u036a', /*     ͪ     */		'\u036b', /*     ͫ     */		'\u036c', /*     ͬ     */		'\u036d', /*     ͭ     */
				'\u036e', /*     ͮ     */		'\u036f', /*     ͯ     */		'\u033e', /*     ̾     */		'\u035b', /*     ͛     */
				'\u0346', /*     ͆     */		'\u031a' /*     ̚     */
			];
var zalgo_down = [
				'\u0316', /*     ̖     */		'\u0317', /*     ̗     */		'\u0318', /*     ̘     */		'\u0319', /*     ̙     */
				'\u031c', /*     ̜     */		'\u031d', /*     ̝     */		'\u031e', /*     ̞     */		'\u031f', /*     ̟     */
				'\u0320', /*     ̠     */		'\u0324', /*     ̤     */		'\u0325', /*     ̥     */		'\u0326', /*     ̦     */
				'\u0329', /*     ̩     */		'\u032a', /*     ̪     */		'\u032b', /*     ̫     */		'\u032c', /*     ̬     */
				'\u032d', /*     ̭     */		'\u032e', /*     ̮     */		'\u032f', /*     ̯     */		'\u0330', /*     ̰     */
				'\u0331', /*     ̱     */		'\u0332', /*     ̲     */		'\u0333', /*     ̳     */		'\u0339', /*     ̹     */
				'\u033a', /*     ̺     */		'\u033b', /*     ̻     */		'\u033c', /*     ̼     */		'\u0345', /*     ͅ     */
				'\u0347', /*     ͇     */		'\u0348', /*     ͈     */		'\u0349', /*     ͉     */		'\u034d', /*     ͍     */
				'\u034e', /*     ͎     */		'\u0353', /*     ͓     */		'\u0354', /*     ͔     */		'\u0355', /*     ͕     */
				'\u0356', /*     ͖     */		'\u0359', /*     ͙     */		'\u035a', /*     ͚     */		'\u0323' /*     ̣     */
			];
var zalgo_mid = [
				'\u0315', /*     ̕     */		'\u031b', /*     ̛     */		'\u0340', /*     ̀     */		'\u0341', /*     ́     */
				'\u0358', /*     ͘     */		'\u0321', /*     ̡     */		'\u0322', /*     ̢     */		'\u0327', /*     ̧     */
				'\u0328', /*     ̨     */		'\u0334', /*     ̴     */		'\u0335', /*     ̵     */		'\u0336', /*     ̶     */
				'\u034f', /*     ͏     */		'\u035c', /*     ͜     */		'\u035d', /*     ͝     */		'\u035e', /*     ͞     */
				'\u035f', /*     ͟     */		'\u0360', /*     ͠     */		'\u0362', /*     ͢     */		'\u0338', /*     ̸     */
				'\u0337', /*     ̷     */		'\u0361', /*     ͡     */		'\u0489' /*     ҉_     */		
			];


// what to do after the event
var i = 0;                     //  set your counter to 1
var word = "You, my creator, abhor me";            // text to be zalgoed up

function myLoop () {           //  create a loop function
   setTimeout(function () {    //  call setTimeout to delay the messages to the channel
      
        word = word.split("");
        
        //adding random zalgo chars
        var x = randint(0, word.length);
        word.splice(x, 0, zalgo_up[randint(0, zalgo_up.length)]);
        var y = randint(0, word.length);
        word.splice(y, 0, zalgo_mid[randint(0, zalgo_mid.length)]);
        var z = randint(0, word.length);
        word.splice(z, 0, zalgo_down[randint(0, zalgo_down.length)]);
       
        
       // removes all the zalgo chars before the first letter (for loop to remove if channel visual takeover is needed
       
       
        for(var count = 0; count<word.length; count++){
            if (is_zalgo_char(word[count])){
                word.splice(count, 1);
                }
            else {break;}
        }
       
        
       
        word = word.join("");
        
        client.say("#zallllgo", word);
        
       
       i++;                     //  increment the counter
      if (i < 1000) {            //  number of messages of increasing zalgoization
         myLoop();             //  function above is called 
      }                        
   }, 3000)                     //lag in between messages to the channel (ms)
}


// listen for a trigger message (var text)
client.addListener("message", function(from, to, text, message) {
    if (text == "zalgo things up") {myLoop();}
    
});