import subprocess
import os
from os import path
import sys
import io
import datetime
from bs4 import BeautifulSoup


# get latest log
logs = []
# point path to purple folder on your computer
path = "../../../../.purple/logs/irc/freakenstein@10.1.1.1"
# find the folder with files
for files in os.listdir(path):
	# save files in list
	logs.append(files)
logs = sorted(logs)
print logs
# select last file of list
filename = logs[-1]
# define full path name file
filename = os.path.join(path, filename)
print filename


corpus = io.open(filename,'r', encoding='utf-8').read()
soup = BeautifulSoup(corpus, "html.parser")
# select sentence objects from xml
t = soup.get_text().replace('br','\n\n') # t is unicode object


# write original log to txt file as back-up
# point to folder where you want to save txt file
syncpath1 = "frankie_shares/logs"
# define full path name file
timenow = datetime.datetime.now()
time = str(timenow).replace(" ", "_")
filename = os.path.join(syncpath1, time+'_logs.txt')
log = open(filename, 'w') 
log.write(t.encode('utf8'))
log.close()
