import sys
import os
import nltk, random, enchant, string, time
from nltk.corpus import wordnet as wn

# type "cat bot | python -u ircpipebot.py --server irc.freenode.net --channel '#algolit' --nickname hahaha1 | python -u permutation.py > bot"
# to start the bot
# should other files be in the folder beside ircpipebot.py ??

d = enchant.Dict("en_GB")
entries = nltk.corpus.cmudict.entries()

def rhyme(a):
    b = [(word, syl) for word, syl in entries if word == a]
    if len(b) == 0: return changeletter(a)
    rhymes = []
    if len(b[0][1])<=3:
        for i in range(len(entries)-1):
            if b[0][1][len(b[0][1])-1] == entries [i][1][len(entries[i][1])-1]:
                if b[0][1][len(b[0][1])-2] == entries [i][1][len(entries[i][1])-2]:
                    if d.check(entries[i][0]): rhymes.append(entries[i][0])
    else:
        for i in range(len(entries)-1):
            if b[0][1][len(b[0][1]) - 1] == entries[i][1][len(entries[i][1]) - 1]:
                if b[0][1][len(b[0][1]) - 2] == entries[i][1][len(entries[i][1]) - 2]:
                    if b[0][1][len(b[0][1]) - 3] == entries[i][1][len(entries[i][1]) - 3]:
                        if d.check(entries[i][0]): rhymes.append(entries[i][0])

    return random.choice(rhymes)

def changeletter(a):
    alphabet = list(string.ascii_lowercase)
    timeout = time.time() + 5
    b = "ezkjhez"  #not in dictionary, just to enter the loop
    while not (d.check(b)):
        b=a
        b = list(b)
        b[random.randint(0,(len(b)-1))]=random.choice(alphabet)
        b = ''.join(b)
        if time.time() > timeout: return a #  breaks if loop continues for more than 5 secs
    return b

def semantic(a):
    if len(wn.synsets(a))==0 : return rhyme(a)  # returns rhyme if not possible
    b = random.choice(wn.synsets(a))
    if len(b.hypernyms())==0: return changeletter(a)  # return changeletter if not possible
    c = random.choice(b.hypernyms())
    d = c.name().split(".")[0]
    d = d.replace("_", " ")
    return d

fl = [rhyme, changeletter, semantic]  # set of functions

phrase = str("misery made me a fiend")
phrase.encode("utf-8")
phrase = nltk.wordpunct_tokenize(phrase)

onewordchanged = []

for i in range(300):
    x = random.randint(0, (len(phrase)-1))
    while len(phrase[x]) <= 3:  # it doesn't change words shorter than 3 letters
        x = random.randint(0, (len(phrase) - 1))
    phrase[x] = random.choice(fl)(phrase[x])
    phrase = " ".join(phrase)
    phrase = phrase.split()
    time.sleep(5)
    print " ".join(phrase)



