#!/usr/bin/python

from datetime import datetime
import re
import time
import sys

print 'Hello spybot...'

idents = {}

date_pattern = re.compile('([A-Za-z])+ [0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}')
ident_pattern = re.compile('DHCP (?:[0-9]{1,3}\.){3}[0-9]{1,3}')
query_pattern = re.compile('query.* from ((?:[0-9]{1,3}\.){3}[0-9]{1,3})')

#def handle_ident_str(str):
#  txt = str.split('DHCP')
#  elems = txt[len(txt) - 1].split(' ')
#  idents[elems[1]] = elems[3].strip()

#print date_pattern.search('May 27 12:11:38').group()

last_date = datetime.now()

with open('/var/log/daemon.log') as f:
  for line in f:
    pass
  date_str = date_pattern.search(line).group()
  last_date = datetime.strptime(date_str, '%b %d %H:%M:%S')

def handle_query_str(str):
  txt = str.split('query')
  elems = txt[len(txt) - 1].split(' ')
  if len(elems) >= 4:
    ip = elems[3].strip()
    req = elems[1].strip()
    try:
      ident = idents[ip]
      print ident + ' spoke to ' + req
    except:
      print ip + ' spoke to ' + req

#query[A] physics.stackexchange.com from 10.1.1.136

while True:
  time.sleep(5)
  with open('/var/lib/misc/dnsmasq.leases') as f:
    for line in f:
      elems = line.split(' ')
      idents[elems[2]] = elems[3]

  with open('/var/log/daemon.log') as f:
    for line in f:
      if query_pattern.search(line) is not None:
        date_str = date_pattern.search(line).group()
        date = datetime.strptime(date_str, '%b %d %H:%M:%S')
        if date > last_date:
          handle_query_str(line)
          last_date = date
  sys.stdout.flush()

